Ship internal tools in hours, not weeks. Real auth, users, jobs, audit logs, and cohesive UI included. Early access $249 $499 → [Get it now]

How to use GraphQL in Angular

GraphQL provides efficient data fetching with client-specified queries, reducing over-fetching and enabling flexible API interactions in Angular applications. As the creator of CoreUI, a widely used open-source UI library, I’ve implemented GraphQL APIs in Angular projects throughout my 12 years of frontend development since 2014. The most straightforward approach is using Angular’s HttpClient to send GraphQL queries as POST requests with query strings and variables. This method enables precise data requirements, type-safe responses with TypeScript interfaces, and reduced network payload compared to REST APIs.

Send GraphQL queries using HttpClient with POST requests containing query strings and variables for flexible data fetching.

import { Injectable } from '@angular/core'
import { HttpClient, HttpHeaders } from '@angular/common/http'
import { Observable } from 'rxjs'
import { map } from 'rxjs/operators'

interface User {
  id: string
  name: string
  email: string
  posts: Post[]
}

interface Post {
  id: string
  title: string
  content: string
  createdAt: string
}

interface GraphQLResponse<T> {
  data: T
  errors?: Array<{ message: string }>
}

@Injectable({
  providedIn: 'root'
})
export class GraphQLService {
  private apiUrl = 'https://api.example.com/graphql'

  constructor(private http: HttpClient) {}

  private query<T>(query: string, variables: any = {}): Observable<T> {
    const headers = new HttpHeaders({
      'Content-Type': 'application/json',
      'Authorization': `Bearer ${this.getToken()}`
    })

    return this.http.post<GraphQLResponse<T>>(
      this.apiUrl,
      { query, variables },
      { headers }
    ).pipe(
      map(response => {
        if (response.errors) {
          throw new Error(response.errors[0].message)
        }
        return response.data
      })
    )
  }

  private getToken(): string {
    return localStorage.getItem('authToken') || ''
  }

  // Query: Fetch single user with posts
  getUser(id: string): Observable<{ user: User }> {
    const query = `
      query GetUser($id: ID!) {
        user(id: $id) {
          id
          name
          email
          posts {
            id
            title
            content
            createdAt
          }
        }
      }
    `
    return this.query(query, { id })
  }

  // Query: Fetch multiple users with pagination
  getUsers(limit: number = 10, offset: number = 0): Observable<{ users: User[] }> {
    const query = `
      query GetUsers($limit: Int!, $offset: Int!) {
        users(limit: $limit, offset: $offset) {
          id
          name
          email
        }
      }
    `
    return this.query(query, { limit, offset })
  }

  // Mutation: Create new post
  createPost(title: string, content: string): Observable<{ createPost: Post }> {
    const mutation = `
      mutation CreatePost($title: String!, $content: String!) {
        createPost(title: $title, content: $content) {
          id
          title
          content
          createdAt
        }
      }
    `
    return this.query(mutation, { title, content })
  }

  // Mutation: Update user profile
  updateUser(id: string, name: string, email: string): Observable<{ updateUser: User }> {
    const mutation = `
      mutation UpdateUser($id: ID!, $name: String!, $email: String!) {
        updateUser(id: $id, name: $name, email: $email) {
          id
          name
          email
        }
      }
    `
    return this.query(mutation, { id, name, email })
  }

  // Mutation: Delete post
  deletePost(id: string): Observable<{ deletePost: boolean }> {
    const mutation = `
      mutation DeletePost($id: ID!) {
        deletePost(id: $id)
      }
    `
    return this.query(mutation, { id })
  }
}

Using GraphQL service in components:

import { Component, OnInit } from '@angular/core'
import { CommonModule } from '@angular/common'
import { FormsModule } from '@angular/forms'
import { GraphQLService } from './graphql.service'

@Component({
  selector: 'app-user-profile',
  standalone: true,
  imports: [CommonModule, FormsModule],
  template: `
    <div class='profile-container'>
      <div *ngIf='loading' class='loading'>
        Loading user data...
      </div>

      <div *ngIf='error' class='error'>
        {{ error }}
      </div>

      <div *ngIf='user && !loading' class='profile'>
        <h2>{{ user.name }}</h2>
        <p>{{ user.email }}</p>

        <div class='posts'>
          <h3>Posts</h3>
          <div *ngFor='let post of user.posts' class='post'>
            <h4>{{ post.title }}</h4>
            <p>{{ post.content }}</p>
            <small>{{ post.createdAt | date }}</small>
            <button (click)='deletePost(post.id)'>Delete</button>
          </div>
        </div>

        <div class='create-post'>
          <h3>Create New Post</h3>
          <input
            [(ngModel)]='newPost.title'
            placeholder='Post title'
            class='form-control'
          >
          <textarea
            [(ngModel)]='newPost.content'
            placeholder='Post content'
            class='form-control'
          ></textarea>
          <button (click)='createPost()'>Create Post</button>
        </div>
      </div>
    </div>
  `
})
export class UserProfileComponent implements OnInit {
  user: any = null
  loading = false
  error = ''
  newPost = { title: '', content: '' }

  constructor(private graphql: GraphQLService) {}

  ngOnInit() {
    this.loadUser('user-123')
  }

  loadUser(id: string) {
    this.loading = true
    this.error = ''

    this.graphql.getUser(id).subscribe({
      next: (response) => {
        this.user = response.user
        this.loading = false
      },
      error: (err) => {
        this.error = err.message
        this.loading = false
      }
    })
  }

  createPost() {
    if (!this.newPost.title || !this.newPost.content) {
      return
    }

    this.graphql.createPost(
      this.newPost.title,
      this.newPost.content
    ).subscribe({
      next: (response) => {
        this.user.posts.push(response.createPost)
        this.newPost = { title: '', content: '' }
      },
      error: (err) => {
        this.error = err.message
      }
    })
  }

  deletePost(id: string) {
    this.graphql.deletePost(id).subscribe({
      next: () => {
        this.user.posts = this.user.posts.filter((p: any) => p.id !== id)
      },
      error: (err) => {
        this.error = err.message
      }
    })
  }
}

Here the GraphQL service wraps HttpClient for sending GraphQL queries as POST requests with query and variables. TypeScript interfaces define expected response shapes for type safety. The query method handles error checking from GraphQL response errors array. Variables passed as separate object enable parameterized queries for dynamic values. Queries use GraphQL syntax specifying exact fields needed, reducing over-fetching. Mutations modify server data using mutation keyword instead of query. The map operator extracts data property from GraphQL response structure.

Best Practice Note:

This is the GraphQL integration approach we use in CoreUI Angular projects when backend provides GraphQL API instead of REST endpoints. Fragment queries for reusable field selections across multiple queries, implement request batching to combine multiple queries into single HTTP request, and consider Apollo Angular client for advanced features like caching, subscriptions, and optimistic UI updates when GraphQL becomes primary API strategy.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Ship internal tools in hours, not weeks. Real auth, users, jobs, audit logs, and cohesive UI included. Early access $249 $499 → [Get it now]

How to use GraphQL in React

Using GraphQL in React lets you request exactly the data your components need — no over-fetching, no under-fetching — with a single flexible endpoint. As the creator of CoreUI with 25 years of web development experience, I’ve used GraphQL in production React dashboards where the ability to query multiple data sources in one request dramatically reduced load times compared to multiple REST calls. For simple use cases, GraphQL works with a plain fetch call. For production apps with caching, optimistic updates, and subscriptions, Apollo Client is the standard choice. Both approaches are covered here so you can choose what fits your project.

Query a GraphQL API with plain fetch — no library needed.

// graphql.js
export async function graphqlFetch(query, variables = {}) {
  const res = await fetch('/graphql', {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json',
      Authorization: `Bearer ${localStorage.getItem('token')}`
    },
    body: JSON.stringify({ query, variables })
  })

  const { data, errors } = await res.json()
  if (errors) throw new Error(errors[0].message)
  return data
}
// In a component
import { useState, useEffect } from 'react'
import { graphqlFetch } from './graphql'

function UserList() {
  const [users, setUsers] = useState([])

  useEffect(() => {
    graphqlFetch(`
      query {
        users {
          id
          name
          email
        }
      }
    `).then(data => setUsers(data.users))
  }, [])

  return <ul>{users.map(u => <li key={u.id}>{u.name}</li>)}</ul>
}

GraphQL always uses POST with a JSON body containing query and optionally variables. The response always has a data object (on success) and/or an errors array. A 200 status code does not mean the query succeeded — always check errors.

Apollo Client Setup

Install Apollo for caching and reactive updates.

npm install @apollo/client graphql
// apolloClient.js
import { ApolloClient, InMemoryCache, createHttpLink } from '@apollo/client'
import { setContext } from '@apollo/client/link/context'

const httpLink = createHttpLink({ uri: '/graphql' })

const authLink = setContext((_, { headers }) => ({
  headers: {
    ...headers,
    authorization: `Bearer ${localStorage.getItem('token')}`
  }
}))

export const client = new ApolloClient({
  link: authLink.concat(httpLink),
  cache: new InMemoryCache()
})
// App.jsx
import { ApolloProvider } from '@apollo/client'
import { client } from './apolloClient'

export default function App() {
  return (
    <ApolloProvider client={client}>
      <UserList />
    </ApolloProvider>
  )
}

Using useQuery Hook

Apollo’s useQuery hook runs the query when the component mounts and provides loading and error states automatically.

import { useQuery, gql } from '@apollo/client'

const GET_USERS = gql`
  query GetUsers {
    users {
      id
      name
      email
      role
    }
  }
`

function UserList() {
  const { loading, error, data } = useQuery(GET_USERS)

  if (loading) return <p>Loading...</p>
  if (error) return <p>Error: {error.message}</p>

  return (
    <ul>
      {data.users.map(user => (
        <li key={user.id}>{user.name}  {user.role}</li>
      ))}
    </ul>
  )
}

useQuery re-runs the query when variables change, integrates with Apollo’s cache to avoid redundant network requests, and automatically updates the component when related mutations write new data.

Using useMutation Hook

import { useMutation, gql } from '@apollo/client'

const CREATE_USER = gql`
  mutation CreateUser($name: String!, $email: String!) {
    createUser(name: $name, email: $email) {
      id
      name
    }
  }
`

function CreateUserForm() {
  const [createUser, { loading }] = useMutation(CREATE_USER, {
    refetchQueries: [{ query: GET_USERS }]
  })

  async function handleSubmit(name, email) {
    await createUser({ variables: { name, email } })
  }

  return <button onClick={() => handleSubmit('Alice', '[email protected]')} disabled={loading}>Create</button>
}

refetchQueries automatically re-fetches the users list after a successful mutation, keeping the UI in sync without manual cache manipulation.

Best Practice Note

This is the same GraphQL setup used in CoreUI React dashboard templates that connect to GraphQL APIs. For simple internal APIs, the plain fetch approach reduces bundle size and complexity. For complex apps with many queries, mutations, and subscriptions, Apollo Client’s normalized cache prevents stale data and reduces API calls. See how to use Apollo Client in React for advanced Apollo patterns including optimistic updates and subscriptions.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author